/* aqv23tst7.C - upgrapde of aqv23tst6.C: now can twist and
   change tracedg from A to B state, incorporated twist routines of 
   V12test/v_ktest4.C
   does all twists and checks invs of A & B state
   outputs twist vectors of dgs passing all tests
   few other errors fixed (help_sum())
*/

#include "mydefs.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

#define MAXCR 100

int cr,a[MAXCR],w[2*MAXCR+1],o[2*MAXCR+1],ln[4*MAXCR*MAXCR+1],nr;
// Dowker code array, crsg nr, diagram nr

#define error { cerr<<"error line " << __LINE__ << endl; } else

inline int MOD(int a, int b=2*cr) {
  ret ((a%b)+b)%b;
}

inline int MOD1(int a, int b=2*cr) {
  ret ((a%b)+b-1)%b+1;
}

inline int NXT(int l) { ret MOD1(l+1); }

inline int DIST(int a, int b) {
  ret min(MOD(a-b),MOD(b-a));
}

inline int othcrs(int i)
{
  i=(2*cr+i%(2*cr))%(2*cr); // || (i=2*cr);
  // make i betw 1 and 2*cr
  ret o[i];
}

bool next()
{
  int i,j;

  // delete [] a;
  // delete [] o;
  // delete [] w;
  // delete [] ln;

  cin>>cr>>nr;


  if(!cin) ret false;

  // TRC(nr);
  // TRC(cr);
  // a=new int[cr];
  // o=new int[2*cr];
  // w=new int[2*cr+1];
  // ln=new int[4*cr*cr];

  for(i=0;i<cr;i++) cin >> a[i];
  // TRC(nr);

  for(i=0;i<2*cr;i++) 
  {
    if(i%2) o[i]= a[i/2];

    for(j=0;j<cr;j++)
      if(abs(a[j])%(2*cr)==i) o[i]= -(1+2*j)*sgn(a[j]);

      // 2*cr is index 0 in o[]; else index of crsg pt i is =i
  }

#define AO(j) abs(othcrs(j))

// o[] is maintained there 

  for(i=1;i<=2*cr;i++) 
   for(j=i;j<=2*cr;j++) {
     int m=max(j,AO(j)),
         n=min(j,AO(j)),
         o=max(i,AO(i)),
         p=min(i,AO(i));

     ln[i-1+2*cr*(j-1)]=ln[j-1+2*cr*(i-1)]=((o-m)*(p-n)*(m-p)*(o-n)>0);
   }


  // outputarray(cerr,w,2*cr);
  // for(i=0;i<cr;cerr<<w[2*i++ +1]<<" ");

  ret cin;
}


inline bool linked(int i, int j)
{
  ret ln[i-1+2*cr*(j-1)];
}

#define betw(c,a,b) ((c)-(a))*((b)-(c))*((b)-(a))>0
// c betw a & b in cycl order 1,2,...,2*cr,1
// e.g. 10 is betw 9 and 1

int writhe(int *f, int *dt, int nc)
{

  int a[2*nc+1], d[2*nc+1], e[2*nc+1], g[2*nc+1], h[2*nc+1];
  int w=0, n=2*nc-1, i, j, k, l, s, t, knit;


    /*
    n=2*nc-1;
    b[0]=n+1;
    b[n+2]=1;
    for (i=1; i<=n+1; i+=1) b[i]=i;
    b1[0]=4;
    b1[5]=1;
    for (i=1; i<=4; i+=1) b1[i]=i;
    */
    
    for (i=1; i<=2*nc; ++i) a[i]=0;
    
    for (i=1; i<=n; i+=2)
    {
      a[i]=dt[i/2];
      d[i]=a[i]/abs(a[i]);
      a[i]=abs(a[i]);
    }
    for(i=1; i<=n; i+=2)
    {
      a[a[i]]=i;
      d[a[i]]=-d[i];
    }
    
    for (i=1; i<=2*nc; ++i) if (a[i] == 0)
    {
      exit(0);
    }    
       
    for (i=1; i<=n+1; i+=1)
    { 
      e[i]=0;f[i]=0;g[i]=0;h[i]=0;
    }
    f[1]=1; f[a[1]]=-1;
    h[1]=1; h[a[1]]=1;
    e[1]=1;
    t=1;
    while (t!=0)
    {
      e[t]=1;
      for (i=t+1; i<=n+1; i+=1)
        if ((a[i]>=t) && (a[i]<=a[t])) 
          e[i]=-e[i-1];
        else 
          e[i]=e[i-1];
      for (i=t-1; i>=1; i-=1)
        if ((a[i+1]>=t) && (a[i+1]<=a[t]))
          e[i]=-e[i+1];
        else
          e[i]=e[i+1];
      for (i=1; i<=t-1; i+=1) g[i]=1;
      for (i=a[t]+1; i<=n+1; i+=1) g[i]=1;
      s=0;i=1;
      while ((s==0) && (i<=n+1))
      {
        if (g[i]==1) s=i;
        i=i+1;
      }
      while (s!=0)
      {
        if ((a[s]<t) || (a[s]>a[t]))
        {
          if (e[s]*e[a[s]]==1)
          {
            g[s]=0;
            g[a[s]]=0;
          }
          if (e[s]*e[a[s]]==-1)
          {
            knit=1;
          }
        }
        else
        {
          if (f[s]!=0)
          {
            if (e[s]*e[a[s]]*f[t]==f[s])
            {
              g[s]=0;
              g[a[s]]=0;
            }
            else
            {
              knit=1;
            }
          }
          else
          {
            f[s]=e[s]*e[a[s]]*f[t];
            f[a[s]]=-f[s];
            if (((s==1) && (abs(a[n+1]-a[1])==1)) ||
              ((s!=1) && 
                ((abs(a[s-1]-a[s])==1) || (abs(a[s-1]-a[s])==n))))
            {
              g[s]=0;
              g[a[s]]=0;
            }
            else
            {
              g[s]=0;
              g[a[s]]=0;
              h[s]=1;
              h[a[s]]=1;
            }
          }
        }
        s=0;
        i=1;
        while ((s==0) && (i<=n+1))
        {
          if (g[i]==1) s=i;
          i=i+1;
        }
      }
      h[t]=0;
      h[a[t]]=0;
      t=0;
      i=1;
      while ((t==0) && (i<=n+1))
      {
        if (h[i]==1) t=i;
        i=i+1;
      }
    }
  
  /*
    for(i=1; i<=n; i+=2)
    {
      j=(i+1)/2;
      if (d[i]==1)
      { 
        w[j][1]=a[i+1]; 
        w[j][3]=a[b[i-1]];
        if (f[i]==-1)
        {
          w[j][2]=b[a[i]+1];
          w[j][4]=(a[i]-1);
        }
        else
        {
          w[j][2]=(a[i]-1);
          w[j][4]=b[a[i]+1];
        }
      }
      if (d[i]==-1)
      {
        w[j][1]=b[a[i]+1];
        w[j][3]=(a[i]-1);
        if (f[i]==-1)
        {
          w[j][2]=a[b[i-1]];
          w[j][4]=a[i+1];
        }
        else
        {
          w[j][2]=a[i+1];
          w[j][4]=a[b[i-1]];
        }
      }
    }
    for (i=1; i<=nc; i+=1) 
      for (j=1; j<=4; j+=1)
        w[i][j]=(w[i][j]+1)/2;
    fprintf(gp1, "%2d.%8d:\n", nc, id);
    */
    
    for (i=1; i<=nc; i+=1)
    {
      /* fprintf(gp1, "%1d", i); */
      w+=(f[2*i-1]*=d[2*i-1]);
    }
  
  f[0]=f[nc*2];

  ret w;
  
}

void print() {
  cout<<cr<<" "<<nr<<" ";

  outputarray(cout,a,cr,"", /* start */
                        " ", /* sep */
                        ""); /* end */
}


#define rint register int
#define cint const int

#define ERROR(a) if(a) { cerr<<"error line "<<__LINE__<<endl; }

inline int abs_member(const int a,const int *b,const u_int j)
{ for(u_int i=0;i<j;) if(abs(b[i++])==a) return i; return 0; }

struct edge {
  int g[2];
  int & oper [] (cint i) { ret g[i]; }
  const int oper [] (cint i) const { ret g[i]; }
  const edge & oper =(const edge & e) { g[1]=e[1]; g[0]=e[0]; ret e; }
  friend int vnr(int v,const edge & e) {
    ret e[0]==v ? 1 : e[1]==v ? 2:0; 
  }
  oper int * () { ret g; }
};

struct graph { // graph
  int nv,ne; // nr vert & edges
  int *verts;
  edge *edges;

  // edges[j][0]...[1] are the source & target verts of
  // ori edge #j (j=0,...,ne-1)
  // a vertex may be negative if it is marked (it's alw a non-0
  // int); even if marked, it does not appear signed in edges[][],
  // though

  ~graph() { delete [] verts; delete [] edges; }

  graph(const graph & g): nv(g.nv), ne(g.ne) {
    verts=copyarray(g.verts,nv);
    edges=copyarray(g.edges,ne);
  }

  const graph & oper =(const graph & g) { 
    delete [] verts; delete [] edges;
    nv=g.nv; ne=g.ne; verts=copyarray(g.verts,nv);     
    edges=copyarray(g.edges,ne);
    ret g;
  }

  graph(int nvr, int ned, int *v=0, int *e=0)
  {
    verts=new int[nv=nvr]; 
    edges=new edge[ne=ned];
    if(v) {
      copyarray(v,nv,verts);
      for(int j=0;j<ne;++j) copyarray(e+2*j,2,(int *)edges[j]);
    }
  }


  friend istream & oper >>(istream &in, graph & g)
  {
    int i,j;
    
    in>>g.nv>>g.ne;
    
    g=graph(g.nv,g.ne);

    for(i=0;i<g.nv;in>>g.verts[i++]);
    
    for(i=0;i<g.ne;++i) for(j=0;j<2;++j) in>>g.edges[i][j];

    ret in;
  }

  friend ostream & oper <<(ostream &o, const graph & g)
  {
    int i,j;
    
    varoutputarray(o<<"[ "<<g.nv,g.verts,g.nv," ("," ",")  |  ");
    o.flush();
    o<<g.ne;
    o.flush();

    for(i=0;i<g.ne;++i) {
      varoutputarray(o,(int *)g.edges[i],2," ("," ",")");
      o.flush();
    }

    ret o<<"  ] ";
  }

  void reduce() // remove loops
  {
    int j;

    for(j=0;j<ne;j++)
    {
      if(edges[j][0]==edges[j][1]) edges[j--]=edges[--ne];
    }
  }

  graph del(int nre) const
  { // delete edge #nre

    graph g=*this;

    g.edges[nre]=g.edges[--g.ne];

    ret g;
  }

  graph propagate() const
  {
    graph g=*this;

    int fl,j,k,l;

    do {

      fl=0;

      for(j=0;j<ne;j++) for(k=0;k<2;++k)

        if((l=member(g.edges[j][k],g.verts,g.nv)) &&
	   ! member(g.edges[j][1-k],g.verts,g.nv)
	  ) 
	  g.verts[l-1]*=-1,fl=1;
    }
    while(fl);

    ret g;
  }

  friend bool full_marked(const graph & g)
  {
    int j;

    for(j=0;j<g.nv && g.verts[j]<0;++j); ret j==g.nv;
  }

  graph mark(int nrv) const
  {
    graph g=*this;

    int j;

    for(j=0;j<g.nv;++j) {
      g.verts[j]=abs(g.verts[j])*(nrv==j?-1:1);
      if(!g.verts[j]) cerr<<"error vert #0 found"<<endl;
    }

    ret g;
  }

  graph add_mark(int vr) const
  {
    // mark vertex named (NOT #ed) vr;

    graph g=*this;

    if(int m=member(vr,g.verts,g.nv)) g.verts[m-1]=-abs(g.verts[m-1]);

    ret g;
  }

  bool isol_vert(int nrv) const
  {
    graph g=mark(nrv);
    ret cmparray(g.verts,g.propagate().verts,g.nv);
  }

  friend bool connd(const graph & g, int *cmp=0) 
  // is g conn'd?
  // if not one can store in cmp[] the markings of vertices
  // of diff comps of g (needed for block component determination
  // in index() )
  {
    graph h=g.mark(0).propagate(); 
    if(cmp) copyarray(h.verts,h.nv,cmp);
    ret full_marked(h);
  }

  bool parallel(int e1, int e2) const {
    // are edges e1, e2 parallel (i.e. form a multiple edge)
    ret edges[e1][0]==edges[e2][0] && edges[e1][1]==edges[e2][1] ||
        edges[e1][1]==edges[e2][0] && edges[e1][0]==edges[e2][1];
  }

  bool adj(int v1, int v2) const {
    // are verts v1,v2 adjacent (i.e. conn'd by an edge)
    for(int i=0;i<ne;++i)
    if(edges[i][0]==v1 && edges[i][1]==v2 ||
       edges[i][0]==v2 && edges[i][1]==v1) ret true;
    ret false;
  }

  bool simple(int enr) const {
    // is edge #enr a simple edge ?
    for(int j=0;j<ne;++j) if(j-enr && parallel(j,enr)) ret false;
    ret true;
  }

  graph cut(int vrt) const { 
    // delete the star of vertex vrt& vert itself
    // vrt must be negative if vertex -vet is marked in *this !
    int nrv=member(vrt,verts,nv)-1,j;
    if(nrv<0) {
      cerr<<" try to del non-exist vrt"<<endl; ret *this;
    }
    graph g=*this;

    for(j=0;j<g.ne;++j) {
      if(vnr(abs(vrt),g.edges[j]))
	// abs() to account for marked vertex
	g.edges[j--]=g.edges[--g.ne];
    }

    g.verts[nrv]=g.verts[--g.nv];

    // TRC(g);
    ret g;
  }
  
  bool isepar() const { // no cut vert?
    // TRC(*this);
    for(int j=0;j<nv;++j) {
      if(!connd(cut(verts[j]))) ret false;
    }
    
    ret connd(*this);
  }

  int atomnr() const { // Mur-Prz index until you reach mx

    if(nv<3) ret 1;
    // TRC(*this);
    int i,j,z,y,x[nv],gi,gj,k;

    // 1st try block sum decomp; but must ensure that cut vertex 
    // is not adjacent to marked edge

    for(j=0;j<nv;++j) {
      if(!connd(cut(y=verts[j]),x)) {      
	graph g=*this, g1=g;
	for(i=0;i<nv-1;++i) {
	  graph & y= x[i]>0 ? g1:g;
	  k=abs_member(abs(x[i]),y.verts,y.nv)-1;
	  ERROR(k<0);
	  y=y.cut(y.verts[k]);
	}
	ret g.atomnr()+g1.atomnr();
      }
    }

    ret 1;
  }
};

class tracedg {
public:
  int ncr, nl, *len, *conn;

  ~tracedg() { delete [] len; delete [] conn; }

  tracedg(const tracedg & g): ncr(g.ncr), nl(g.nl) {
    len=copyarray(g.len,nl);
    conn=copyarray(g.conn,nl*ncr);
  }

  const tracedg & oper =(const tracedg & g) { 
    delete [] len; delete [] conn;
    ncr=g.ncr; len=copyarray(g.len,nl=g.nl);     
    conn=copyarray(g.conn,ncr*ncr);
    ret g;
  }

  tracedg(cint nc=0, cint nlp=0,  cint *l=0, cint **c=0)
  {
    // TRC(nc);
    ncr=nc;
    len=new int[nl=nlp]; 
    conn=new int[nl*nc];
    // TRC(l);
    if(l) {
      copyarray(l,nl,len);
      for(int j=0;j<nl;++j) {
	// TRC(j);
	copyarray(c[j],l[j],conn+nc*j);
      }
    }
    // TRC(*this);
  }


  friend istream & oper >>(istream &in, tracedg & g)
  {
    int i,j;
    // in must contain:
    // #crsgs, #loops, array of lengths (#of trace basepts) for
    // loops, arrays of basepts (numbered from 1)
    
    in>>g.ncr>>g.nl;
    
    g=tracedg(g.ncr,g.nl);

    for(i=0;i<g.nl;in>>g.len[i++]);
    
    for(i=0;i<g.nl;++i) for(j=0;j<g.len[i];++j)
      in>>g.conn[i*g.ncr+j];

    ret in;
  }

  friend ostream & oper <<(ostream &o, const tracedg & g)
  {
    int i;
    
    varoutputarray(o<<"[ "<<g.ncr<<" "<<g.nl,
      g.len,g.nl," ("," ",")  |  ");

    for(i=0;i<g.nl;++i) {
      varoutputarray(
	o,g.conn+i*g.ncr, g.len[i]," ("," ",") "
      );
      o.flush();
    }

    ret o<<"  ] ";
  }

  tracedg AtoB (int &nnq) const;
  tracedg del(int e) const;
  tracedg mult(int e, int mult) const;
  int nrcomp() const;
  
};

tracedg tracedg::del(int e) const {

  int i,j,k,l,y,ncn[nl*ncr],nln[nl],*x[nl],*p=ncn;
  for(l=i=0;i<nl;++i)
  { x[l]=p;
    for(k=j=0;j<len[i];++j)
    { y=conn[i*ncr+j];
      if(y-e) p[k++]=y>e?y-1:y;
    }
    if(nln[l]=k) { ++l; p+=k; }
    // delete empty loops
  }
  ret tracedg(ncr-1,l,nln,(const int**)x);
}

tracedg tracedg::mult(int e, int mult) const {

  // it makes edge e into mult parallel ones, by keeping e
  // and adding edges with labels ncr+1,...,ncr+mult-1

  int i,j,k,l,y,o=0, nncr=ncr+mult-1,
      // nncr = new nr of crsgs
      ncn[nl*nncr],nln[nl],*x[nl],*p=ncn;

  for(i=0;i<nl;++i)
  { x[i]=p;
    for(k=j=0;j<len[i];++j)
    { if((p[k++]=conn[i*ncr+j])==e) {
	// since new edges must be placed on 
	// neighboring loops in reverse order to keep orientations
	// coherent, in o we record if we already passed one
	// loop connected by e or not
        if(o++)
	{ --k; for(l=nncr; l>ncr; p[k++]=l--); p[k++]=e; }
	else
	{ for(l=ncr; l<nncr; p[k++]=++l); }
      }
    }
    nln[i]=k;
    p+=k;
  }
  ret tracedg(nncr,nl,nln,(const int**)x);
}


tracedg twist(const tracedg & td, int *tvec)
{
  // tvec should have length==#crsgs in td, and the
  // result should be that crsg #i in td is replaced by
  // tvec[i-1] parallel copies

  // note this in order not to mix up the labels of the
  // crsgs one must 1st perform all non-deletions twistings
  // and then all deletions, with the deleted edges in descending order

  tracedg g=td;
  int i,n=td.ncr;
  for(i=0;i<n;++i) if(tvec[i]>1) g=g.mult(i+1,tvec[i]);
  // TRC(g);
  for(i=n;i--;) if(!tvec[i]) {
    g=g.del(i+1);
    // TRC(i+1);
    // TRC(g);
  }
  ret g;
}

int tracedg::nrcomp () const {

// this counts the nr of components of the link dg
// of which *this is the A-state

  int n2=ncr+2, s,i,d,j,l,e,t,y, np[ncr][2],q[ncr][2];
 
  for(j=0;j<ncr;++j) for(i=0;i<2;++i) np[j][i]=q[j][i]=0;
  // np[i][] records the loops joined by crsg trace #i+1
  // (keep in mind we # crsg traces from 1)
  // q[] is a dummy which crsgs have been traced
 
  for(j=0;j<nl;++j) for(i=0;i<len[j];++i)
  { e=conn[j*ncr+i];
    np[e-1][np[e-1][0]?1:0]=j;
  }
 
  // now q[i][j] indicates if component traced that
  // goes from crsg j+1 in direction i?1:-1 along
  // lower marked loop conn'd by crsg trace of j

  int dir,s0,nrcmp=0;
  for(j=0;j<ncr;j++) for(i=0;i<2;i++) if(q[j][i]==0)
  {
    ++nrcmp;
    t=j+1; 
    dir=d=i+i-1;
    s=s0=(np[j][0]<np[j][1]?0:1);
    // you alw start tracing a component from the
    // lower nrumered loop of the crsg you start with

    do {
 
      // TRC(t);
      q[t-1][dir<0?0:1]=1;
      l=np[t-1][s];
      y=member(t,conn+l*ncr,len[l]);
      ERROR(!y);
      if(dir<0) y+=len[l]-2;
      y=y%len[l];
      t=conn[l*ncr+y];
      ERROR(t<1 || t>ncr);
 
      // if you get both basept of a trace on the same loop
      // then remove them and set the inaq crsg counter nnq up
      s= (np[t-1][0]==l?1:0);
      ERROR(np[t-1][1-s]-l);
      dir*=-1;

    } while(t-j-1 || s-s0 || dir-d);
 
  }  

  ret nrcmp;
}

tracedg tracedg::AtoB (int &nnq) const {

// this transforms *this into the B state loop dg
// assuming cyclic order in the loop arrays of *this
// is coherent; if B state is inadequate, all inaq
// loops are removed, and the nr of such loops is
// recorded in nnq (if B state is adequate, then nnq==0)

  int n2=ncr+2, s,i,w,j,k,l,e,t,y,
      np[ncr][2],ncn[n2*ncr],nlen[n2],*x[n2],q[ncr][2],na[ncr];
 
  for(j=0;j<ncr;++j) for(i=0;i<2;++i) np[j][i]=q[j][i]=0;
  // np[i][] records the loops joined by crsg trace #i+1
  // (keep in mind we # crsg traces from 1)
  // q[] is a dummy which crsgs have been traces
 
  // nnq counts nr of inaq crsgs in B state
  // na[] collects B-inaq crsgs for internal renumbering
 
  for(j=0;j<nl;++j) for(i=0;i<len[j];++i)
  { e=conn[j*ncr+i];
    np[e-1][np[e-1][0]?1:0]=j;
  }
 
  int *p=ncn,lcnt=0;
  for(nnq=lcnt=j=0;j<ncr;j++) for(i=0;i<2;i++) if(q[j][i]==0)
  {
    x[lcnt]=p;
    int &u=nlen[lcnt];
    u=0;
    t=j+1;
    s=i;

    do {
 
      // TRC(t);
      // TRC(s);
      q[t-1][s]=1;
      l=np[t-1][s];
      y=member(t,conn+l*ncr,len[l]);
      ERROR(!y);
      y=y%len[l];
      t=conn[l*ncr+y];
      ERROR(t<1 || t>ncr);
 
      // if you get both basept of a trace on the same loop
      // then remove them and set the inaq crsg counter nnq up
      if(w=member(t,p,u)) {
        na[nnq++]=t;
        copyarray(p+w,u-w,p+w-1);
        // this call is unclean, but makes use of the internal
        // knowledge that copyarray() copies the arrays forwardly
        --u;
      }
      else
      // no double trace
      p[u++]=t;
 
      s= (np[t-1][0]==l?1:0);
      ERROR(np[t-1][1-s]-l);

    } while(t-j-1 || s-i);
 
    p+=u;
    ++lcnt;
  }  

  if(nnq) {
    // exist inaq crsgs in B state;
    // now must renumber crsgs to discard inaq ones

    qsort(na,nnq);
    // TRCA(na,nnq);

    int nnr[ncr+1];
    // nnr[i] is the new nr of crsg #i
    
    for(k=0,i=1;i<=ncr;++i)
    {
      while(k<nnq && i==na[k]) nnr[i++]=0,++k;
      nnr[i]=i-k;
      // TRC(i);
      // TRC(k);
      ERROR(!nnr[i]);
    }
    // TRCA(nnr+1,i);

    for(i=0;i<lcnt;++i) for(j=0;j<nlen[i];++j)
    { 
      x[i][j]=nnr[x[i][j]];
      ERROR(!x[i][j]);
    }
  }
  ret tracedg(ncr-nnq,lcnt,nlen,(const int**)x);
}

// bool saqchk(int cr, int *dow, int sg, tracedg & tr, int &wr) 
// // is dow sg-semiadeq (+=A, -=B)
// // xa = xhi(A(D)), ntri=nr of triangles, xig=chi(IG(A))
// // al = # loops in A(D), anr = c(D)-a_A(D) (atom nr of A(D))
// // NOW ENTRIES IN nnr[][] START FROM 1
// {
//   int i,x,j,dr,k,ns=0,cr2=2*cr,np[cr][2],
//        y,nnr[cr][cr],nr[cr],w[cr2];
// 
//   // TRCA(dow,cr);
//   // TRC(sg);
//   for(j=0;j<cr;j++) for(i=0;i<cr;i++) nnr[i][j]=np[i][j%2]=0;
//   // np counts which outgoing arc of which crsgs belongs to
//   // which loop
//   // nnr records the crsg traces for the separate loops
// 
//   // TRC(writhe(w,dow,cr));
//   // TRCA(dow,cr);
//   wr=writhe(w,dow,cr); //
//   zeroarray(nr,cr);
//   // zeroarray(op,cr);
// 
//   for(y=0;y<2;y++)
//   for(j=0;j<cr;j++)
//   {
//      if(np[j][y]==0)
//      // did not yet trace the loop from crsg #j in direction y
//      {
// 	++ns;
//         k=x=2*j+1;
// 	dr=y?y:-1;
// 	nr[ns-1]=0;
// 
//         do { 
// 	
// 	  if(ns==np[x/2][dr<0?1:0]) ret false;
// 
// 	  // TRC(ns-1);
// 	  // TRC(nr[ns-1]);
// 	  // TRC(x/2);
// 	  if(np[x/2][dr<0?0:dr]) cerr<<"cerr 345"<<endl;
// 	  np[x/2][dr<0?0:dr]=ns;
//  	  nnr[ns-1][nr[ns-1]++]=x/2+1;
// 	  dr*=sg*w[x];
// 
// 	  x=(abs(dow[x/2])+dr)%cr2;
// 
// 	}
//         while(x!=k || dr!=(y?y:-1));
//      }
//   }
// 
//   int *nna[ns];
//   for(j=0;j<ns;j++) nna[j]=nnr[j];
// 
//   tr=tracedg(cr,ns,nr,(cint **)nna);
//   ret true;
// }

int saqchktr(const tracedg & tr, int &xa, int &ntri,
  int &xig, int &al, int &anr) 
// is dow sg-semiadeq (+=A, -=B)
// xa = xhi(A(D)), ntri=nr of triangles, xig=chi(IG(A))
// al = # loops in A(D), anr = a_A(D) (atom nr of A(D))
{
  // TRC(1);
  int i,x,j,dr,k,ee,e,e2,cr=tr.ncr,ns=tr.nl,cr2=2*cr,other_lop,
       r,y,nnr[ns][cr],nr[cr],w[cr2];

  // TRC(2);
  al=ns;

  // TRC(3);
  int cn[ns][ns],connchg[ns][ns],vrt[ns],ed[2*cr],np[cr][2];
  for(j=0;j<ns;j++) for(i=0;i<ns;i++)
    cn[i][j]= connchg[i][j]=0;
  for(j=0;j<cr;j++) for(i=0;i<2;i++) np[j][i]=0;

  // TRC(tr);
  for(j=0;j<ns;++j) { 
    nr[j]=tr.len[j];
    for(i=0;i<nr[j];++i) {
      e=nnr[j][i]=tr.conn[j*cr+i];
      for(k=0;k<2 && np[e-1][k];++k);
      if(k<2) np[e-1][k]=j;
      // NOTE THAT THIS WORKS WELL EVEN IF WE WORK HERE WITH
      // LOOPS j NUMBERED FROM 0
    }
  }
  // TRC(tr);
  // for(i=0;i<cr;++i) TRCA(np[i],2);
  for(j=0;j<ns;++j) {
    nr[j]=tr.len[j];
    for(i=0;i<nr[j];++i) {
      e=nnr[j][i];
      other_lop=np[e-1][np[e-1][0]==j?1:0];
      if(other_lop>j) {
	++cn[other_lop][j];
	++cn[j][other_lop];
      } 
      // copyarray(tr.conn+j*cr, nr[j]=tr.len[j], nnr[j]); 
    }
  }
  // TRC(ns);

  for(e=ee=j=0;j<ns;j++) for(i=vrt[j]=j+1;i<ns;i++) {
     if(cn[i][j]) {
       ed[2*e]=j+1;
       ed[2*e+1]=i+1;
       ++e;
       if(cn[i][j]>1) ++ee; 
     }
  }
  // TRC(ns);

  // TRC(graph(ns,e,vrt,ed).atomnr());
  anr=graph(ns,e,vrt,ed).atomnr();
  // counts mult edges in ee and reduces y from #verts to
  // Euler char of G(A)
  // TRC(anr);

  // TRC(ns);
  // TRC(xa);
  // TRC(y);
  // TRC(y);
  xa=ns-e;
  // Euler char of G(A)

  // this counts the triangles
  for(y=j=0;j<ns;j++) for(i=j+1;i<ns;i++) if(cn[i][j]) {
    for(k=i+1;k<ns;k++)  if(cn[k][j] && cn[i][k]) y++;
  }

  // TRC(y);
  ntri=y;
  
  // TRCA(nr,ns);
  // TRC(tr);
  for(j=0;j<ns;j++) {
    r=nr[j];
    // TRC(j);
    // TRC(r);
    if(r<4) cont;
    int x[cr],*olop=nnr[j],crs,l,m;
    // TRC(j);

    // olop[] records the ther loops j is conn'd to
    // by tre traces in cyclic order

    for(k=0;k<ns;k++) for(i=0;i<ns;i++) connchg[k][i]=0;

    // TRCA(olop,r);
    for(i=0;i<r;++i) {
      e=olop[i];
      m=np[e-1][np[e-1][0]==j?1:0];
      zeroarray(x,cr);
      // x[] counts for what edges l neightbored to j &diff from m
      // the switch of connection betw traces of l and m on j
      // has been accounted for
      for(k=(i+1)%r;
          e2=olop[k],(l=np[e2-1][np[e2-1][0]==j?1:0])-m;
	  k=(k+1)%r
	 )
      {
        if(x[l]==0) {
           x[l]= ++connchg[l][m]; ++connchg[m][l];
        }
        // TRC(k);
      } // for k
    } // for i
    // TRC(j);
 
    for(k=ns-1;k>=0;--k) for(i=k-1;i>=0;--i)
    {
      if(connchg[k][i]%2 // && connchg[k][i]>0
	 ) { 
        // TRC(i);
        // TRC(k);
	// TRCA(olop,r);
	// TRC(connchg[k][i]);
        cerr<<"error!!!"<<endl; 
      }
      if(connchg[k][i]>2) ee--;
    }
  } // for j
 
  // TRC(ee);
  xig=ee;
  ret true;
}

// this now tests and prints twist vectors whose dgs
// match all invs we can calculate

void test(const tracedg & t, int *X, int ln)
{
   ERROR(ln-t.ncr);
   int nq;
   // TRC(twist(t,X));
   tracedg td1=twist(t,X),td2=td1.AtoB(nq),td[2]={td1,td2};
   // TRC(td1);
   // TRC(td2);
   // ERROR(nq==0 && td1.nrcomp()-td2.nrcomp());
   if(nq || td1.nrcomp()>1) ret;
   int j, xa, ntri, xig, al, an;

   for(j=0;j<=1;j++) {
     saqchktr(td[j],xa,ntri,xig,al,an);
     if(xa || ntri || xig || an-4) 
       // test for the specific data of our knots
     {
       break;
     }
   }
   if(j==2) TRCA(X,ln);
}

//
// this is now from V12test/v_ktest4.C 
//

int four, five, six;
static int a_flag=0;

// five is the twist vector entry for non-trivial
// second twist ; six is needed for technical reasons

inline bool GROS(int *x,int j) { ret member(five,x,j) || member(four,x,j); }

int setvalues (int *x, int restr, int modus)
{
  // generates next admissible vector for valence 3-cicrle
  // attached at cycle loop;
  // valence 3-cicrle has 3 outer edges g,i,h

  // x is int[3]
  // 1st time must be called with modus=0, then with
  // modus>0;
  // restr is 0 iff in previous conf a cycle in B'(D)
  // has not yet been encountered (i.e. if one can
  // still create a cycle now)

  // ret value: -1 if all admissible settings exhausted,
  // else generate next setting, and ret 0 if no restr,
  // or 1 if restr (B'(D) has encountered cycle)

  int &g=x[0], &h=x[1], &i=x[2], j;

  if(!modus) { zeroarray(x,3); }
  // TRCA(x,3);


  for(;;) {
    if(modus) {
      for(j=2;j>=0 && 
	(x[j]=x[j]==2?four:x[j]+1)>=
	// we admit only alues 0,1,2,five for x[j]
	// 3 &4 are out bec we need odd length cycle (not pos)
	// of length >3 (no triangles, since V_2(2-cable) measures
	// this)

	( GROS(x,j) ? 3 : six ) ;
	
	 x[j--]=0);
      if(j<0) ret -1;
    }

    if(restr && GROS(x,3) ||
       g+h+i>0 && !(g%2+h%2+i%2) ||
       // all outer edges even - no knot
       g+h+i>0 && g*h*i==0
       // edges missing 
      )
      // inconsistent

      modus = 1;
      // do not initialize next iteration

      else ret max ( restr ,  GROS(x,3) ? 1 : 0);
  } // for
}

int setvalues_pair (int *x, int restr, int modus, int strt=0)
{
  // generates next admissible vector for valence 2-cicrle
  // attached at cycle loop;
  // valence 2-cicrle has outer edges a,b

  // x is int[2]
  // 1st time must be called with modus=0, then with
  // modus>0;
  // restr is 0 iff in previous conf a cycle in B'(D)
  // has not yet been encountered (i.e. if one can
  // still create a cycle now)

  // ret value: -1 if all admissible settings exhausted,
  // else generate next setting, and ret 0 if no restr,
  // or 1 if restr (B'(D) has encountered cycle)

  int j;
  const int vec[4][2]={{0,0},{1,1},{1,4},{2,5}};

  if(!modus) { j=strt ; } else {
    for(j=0;j<4 && diffarray(x,vec[j],2);++j); ++j;
    if(j>3 || restr && j>1) ret -1;
  }

  copyarray(vec[j],2,x);
  ret max ( restr , j>1 ? 1 : 0);
}

// THIS GOT OBSOLETE WHEN EXCLUDING PARALLEL LOOPS
// int setvalues_2pairs (int *x, int restr, int modus)
// {
//   // generates next admissible vector for a parallel pair of 
//   // valence 2-cicrles
//   // 1. valence 2-cicrle has outer edges a,b
//   // 2. valence 2-cicrle has outer edges c,d
// 
//   // x is int[4]
//   // 1st time must be called with modus=0, then with
//   // modus>0;
//   // restr is 0 iff in previous conf a cycle in B'(D)
//   // has not yet been encountered (i.e. if one can
//   // still create a cycle now)
// 
//   // ret value: -1 if all admissible settings exhausted,
//   // else generate next setting, and ret 0 if no restr,
//   // or 1 if restr (B'(D) has encountered cycle)
// 
//   int j;
//   const int vec[4][4]={{0,0,0,0},{1,1,0,0},{1,4,0,0},{2,5,0,0}};
// 
//   if(!modus) { j=0 ; } else  { 
//     for(j=0;j<4 && diffarray(x,vec[j],4);++j);  ++j;
//     if(j>3 || restr && j>1) ret -1;
//   }
// 
//   copyarray(vec[j],4,x);
//   // TRCA(x,4);
//   ret max ( restr , j>1 ? 1 : 0 );
// 
// }

// the foll procs generate multiplicities of outer cycle
// edges 

// we assume outer cycle has len=4 (i.e. we smooth one crsg in
// orig dg and invert one of the components to obtain a positive
// dg). Last 2 edges connect two loops nieghtbored to one with non-empty
// interior to other 4th loop and are alw single

int setvalues_cycle_a (int *w, int restr, int modus)
{ 
  int &a=w[0], &b=w[1], &c=w[2], &d=w[3], &x=w[4], &y=w[5], &z=w[6], j;

  const int strt[7]={1,1,1,1,0,0,0};
  if (!modus) { copyarray(strt,7,w); }

  for(;;) {
    if(modus) {
      for(j=6;j>=0 && 
	(w[j]=w[j]==2?four:w[j]+1)>=
	// we admit only alues 1,2,five for w[j]

	( restr || GROS(w,j) ? 3 : six ) ;
	
	w[j]= strt[j], --j );
      if(j<2) { 
	if(a>1 && b>1) a_flag=2; else if (a>1||b>1) a_flag=1; 
	else a_flag=0; 
      }
      if(j<0) ret -1;
    }

    if(restr && GROS(w,7) || // if restr no >=3 is ok
       a>1 || //can avoid by mutations
       0==x+y || // then connected in interor regs identify and
		 // we have a special case of b
       0==d%2+x%2+z%2+b%2 ||
       0==y%2+c%2+a%2 ||
       0==d%2+x%2+z%2+y%2+c%2 ||
       0==a%2+b%2 // then disconnected
      ) 
      // inconsistent

      modus = 1;

      else ret max ( restr , GROS(w,7) ? 1 : 0 );
  } // for
}

int setvalues_cycle_b (int *w, int restr, int modus)
{ 
  int &a=w[0], &b=w[1], &c=w[2], &d=w[3], &x=w[4], &y=w[5], j;
  const int strt[6]={1,1,1,1,0,0};

  if (!modus) { copyarray(strt,6,w); }

  for(;;) {
    if(modus) {
      for(j=5;j>=0 && 
	(w[j]=w[j]==2?four:w[j]+1)>=
	// we admit only alues 0,1,2,five for w[j]

	( restr || GROS(w,j) ? 3 : six ) ;
	
	w[j]= strt[j],--j );
      if(j<2) { 
	if(a>1 && b>1) a_flag=2; else if (a>1||b>1) a_flag=1; 
	else a_flag=0; 
      }
      if(j<0) ret -1;
    }

    if(// restr==2 && (c-1 || y || d-2 || x-1) ||
       // in case mult edge c=1, y=0, d=2, x=1
       restr && GROS(w,6) || // if restr no >=3 is ok

       a>1 || b==a && c+y>d+x || // then can flip by 180 deg 
	 // or do mutations

       0==a%2+y%2+c%2 ||
       0==x%2+d%2+b%2 ||
       0==x%2+d%2+c%2+y%2 ||
       0==a%2+b%2 // then disconnected
      ) 
      // inconsistent

      modus = 1;

      else ret max ( restr , GROS(w,6) ? 1 : 0 );
  } // for
}

// now come armissible twist vector generation routines

int sum(const int *X, int len)
{ int i,s;
  for (i=s=0;i<len;s+=X[i++]);
  ret s;
}

#define R(i) ((i)>1?1:0)
#define S(i) ((i)>0?1:0)
#define T(i) (S(*(i)))

void conf_a(const tracedg & k)
{
  // A-3, B-2, C-2, D-2, E-2, F-2, G-2, outer-7,
  // one fixed out single edge
  // total X-23
  // TRC(k);
  if(k.ncr-23 && k.ncr)
    { cerr<<"wrong crsg nr in conf_a"<<endl; ret; }

  // the cases in which to two cycle loops inside sth is
  // attached
  int X[23], *A=X, *B=A+3, *C=B+2, *D=C+2, *E=D+2,
    *F=E+2, *G=F+2, *outer=G+2,
   
    r, s, t, u, v, w, x, o;

  X[22]=1;
  for(r=0; r=setvalues     (A,0,  r)+1;)
  for(s=0; s=setvalues_pair(B,r-1,s)+1;)
  for(t=0; t=setvalues_pair(C,s-1,t)+1;)
  for(u=0; u=setvalues_pair(D,t-1,u)+1;)

  if(T(A)+T(B)+ T(C) + T(D)>1)
  // since no mult betw A,B,C at least 2 must be there

  for(v=0; v=setvalues_pair(E,u-1,v)+1;)
  for(w=0; w=setvalues_pair(F,v-1,w)+1;)
  for(x=0; x=setvalues_pair(G,w-1,x)+1;)
  for(o=0; o=setvalues_cycle_a(outer,x-1,o)+1;)
  if(o>0 && sum(X,22)%2 && T(A)+T(B)+T(C)+T(D)+T(E)+T(F)+T(G)==3) {
    // TRCA(X,23); 
    if(outer[0]>1 && outer[1]>1 && a_flag-2 ||
       (outer[0]>1 || outer[1]>1) && a_flag==0 ||
       outer[0]+outer[1]==2 && a_flag
      ) {
      TRCA(X,23);
      TRC(a_flag);
      TRC(outer[0]);
      TRC(outer[1]);
    }
    test(k,X,23); 
    // at least one group >2 must be there
    // total crsg nr must be odd since our initial dg has even
    // crsg nr and we removed one crsg in cycle of A(D)
  }
}

inline int help_sum(int *y, int k)
{
  int s;
  for(s=0;k--;s+=T(y-=(k?2:3)));
  ret s;
}
#define HS help_sum

void conf_b(const tracedg & k)
{
  // HERE HAVE REMOVED PARALLEL LOOPS IN B,C,D,E,F,G AND THE LOOP I

  // A-3, B-2, C-2, D-2, E-2, F-2, G-2, H-3, outer-6
  // one fixed out single edge
  // total X-25
  if(k.ncr-25 && k.ncr)
    { cerr<<"wrong crsg nr in conf_b"<<endl; ret; }

  // the cases in which to two cycle loops inside sth is
  // attached
  int X[25], *A=X, *B=A+3, *C=B+2, *D=C+2, *E=D+2, *F=E+2, *G=F+2,
      *H=G+2, *O=H+3,
   
      r, s, t, u, v, w, x, y, o, me, Or, os, ot, ou, ov, ow, ox, oy;
      // me is count for chi(IG) and Or...oy are temp
      // storage of values of me in each loop

  int &a=*A, &h=*H;

  X[24]=1;
  for(o=0; o=setvalues_cycle_b(O, 0,o)+1;) {
    me=R(O[0])+R(O[1])+R(O[2]+O[5])+R(O[3]+O[4]);
    for(r=0,Or=me; r=setvalues(A,o-1,r)+1;me=Or) {
      me+=S(a)*(1-S(O[4])-S(O[5]));
      if(me>=-2) for(s=0,os=me; s=setvalues_pair(B,r-1,s)+1;me=os) {
	me+=T(B)*(1-S(O[4])-S(O[5]));
        if(me>=-2) for(t=0,ot=me; t=setvalues_pair(C,s-1,t)+1;me=ot) {
           me+=T(C)*(1-S(O[4])-S(O[5]));
           if(me>=-1)
           for(u=0,ou=me; u=setvalues_pair(D,t-1,u)+1;me=ou) {
	     me+=T(D);
             if(me>=0 && HS(E,4)<=3 && HS(E,4)>1)
               // among A,B,C,D at least 2 & at most 3 must be there
	       for(v=0,ov=me; v=setvalues_pair(E,u-1,v)+1;me=ov) {
	       me+=T(E)*(1-S(a)-T(B)-T(D));
	       if(me<=ov && me>=0 && HS(F,5)<=3)
	       for(w=0,ow=me; w=setvalues_pair(F,v-1,w)+1;me=ow) {
		 me+=T(F)*(1-S(a)-T(C)-T(D));
		 if(me<=ow && me>=0 && HS(G,6)<=3)
		 for(x=0,ox=me; x=setvalues_pair(G,w-1,x)+1;me=ox) {
		   me+=T(G)*(1-S(a)-T(C)-T(B));
		   if(me<=ox && me>=0 && HS(H,7)<=3)
		   for(y=0,oy=me; y=setvalues(H,x-1,y)+1;me=oy) {
		     me+=S(h)*(1-S(a)-T(C)-T(B)-T(D));
		     // me<=oy bec by above check
		     // S(a)-T(C)-T(B)-T(D)=HS(E,4)>1
                     if(y>0 && me==0 && sum(X,24)%2 &&
		         T(A)+T(B)+T(C)+T(D)+T(E)+T(F)+T(G)+T(H)==3
		       ) {
			   // TRCA(X,25);
			   test(k,X,25); 
			 }
		   } // for y
		 } // for x
	       } // for w
	     } // for v
	   } // for u
	 } // for t
       } // for s
     } // for r
   } // for o
}

// here end routines of V12test/v_ktest4.C 


main(int argc, char *argv[]) { 

/*
  tracedg tr;
  ifstream is("trace2.in",ios::in);
  is>>tr;
  int i,g[6]={0,0,4,2,2,2};
  // TRC(tr);
  TRC(twist(tr,g).nrcomp());
  TRC(twist(tr,g).AtoB(i));
  TRC(i);
  exit(0); 
*/

  tracedg t1,t4;
  ifstream f1("trdg_a.in",ios::in),
	   f4("trdg_b.in",ios::in);

	   f1>>t1;
	   f4>>t4;

  for(five=5;five<6;++five)
  {
    six=five+1;
    four=five-1;
    cout<<"Fig 4 (a)"<<endl;
    conf_a(t1);
    cout<<"Fig 4 (b)"<<endl;
    conf_b(t4);
  }
}

// main(int argc, char *argv[]) 
// {
// 
//   if(argc>1) {
//     cout<<"output: cnr kid writhe {| [AB] chi(G) #tri "
// 	  "chi(IG) #loops #cr-#atoms}"<<endl;
//     exit(0);
//   }
// 
//   int xa, ntri, xig, al, wr, an, i, qf;
// 
//   tracedg tr;
// 
//   ifstream is("trace2.in",ios::in);
//   is>>tr;
//   int g[6]={0,0,4,0,2,2};
//   // TRC(tr);
//   TRC(twist(tr,g));
//   TRC(twist(tr,g).AtoB(i));
//   TRC(i);
//   exit(0); 
// 
//   while(next()) { 
//     cout<<cr<<" "<<nr<<" ";
//     for(qf=i=1;i>=-1;i-=2) if(saqchk(cr,a,i,tr,wr))
//     {   // TRC(tr);
// 	saqchktr(tr,xa,ntri,xig,al,an);
// 	if(qf) cout<<tostr(wr)+" ", qf=0;
// 	cout<<"| "<<"B A"[i+1]<<" "<<xa
// 	    <<" "<<ntri<<" "<<xig<<" "<<al<<" "<<an<<" ";
//     }
//     cout<<endl;
//   }
// 
//   cout<<cr<<" "<<nr<<" "<<"end\n";
// 
// }
